/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_controllers/ethercat_trigger_controllers/msg/MultiWaveform.msg.  Do not edit! */
#ifndef ETHERCAT_TRIGGER_CONTROLLERS_MULTIWAVEFORM_H
#define ETHERCAT_TRIGGER_CONTROLLERS_MULTIWAVEFORM_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "ethercat_trigger_controllers/MultiWaveformTransition.h"

namespace ethercat_trigger_controllers
{

//! \htmlinclude MultiWaveform.msg.html

class MultiWaveform : public ros::Message
{
public:
  typedef boost::shared_ptr<MultiWaveform> Ptr;
  typedef boost::shared_ptr<MultiWaveform const> ConstPtr;

  typedef double _period_type;
  typedef double _zero_offset_type;
  typedef std::vector<ethercat_trigger_controllers::MultiWaveformTransition> _transitions_type;

  double period;
  double zero_offset;
  std::vector<ethercat_trigger_controllers::MultiWaveformTransition> transitions;

  MultiWaveform() : ros::Message(),
    period(0),
    zero_offset(0)
  {
  }
  MultiWaveform(const MultiWaveform &copy) : ros::Message(),
    period(copy.period),
    zero_offset(copy.zero_offset)
  {
    (void)copy;
    transitions = copy.transitions;
  }
  MultiWaveform &operator =(const MultiWaveform &copy)
  {
    if (this == &copy)
      return *this;
    transitions.clear();
    period = copy.period;
    zero_offset = copy.zero_offset;
    transitions = copy.transitions;
    return *this;
  }
  virtual ~MultiWaveform() 
  {
    transitions.clear();
  }
  inline static std::string __s_getDataType() { return std::string("ethercat_trigger_controllers/MultiWaveform"); }
  inline static std::string __s_getMD5Sum() { return std::string("6a8e166563c159e73f391a302e7b37f6"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Transitions will occur at k * period + zero_offset + transitions[j].time, where j and\n"
    "# k are integers.\n"
    "\n"
    "float64 period # Period of the waveform in seconds.\n"
    "float64 zero_offset # Time corresponding to a time of 0 in times[] in seconds\n"
    "MultiWaveformTransition[] transitions # Transitions in the waveform. Transition times should be in increasing order, and be between 0 (inclusive) and period (exclusive)\n"
    "\n"
    "================================================================================\n"
    "MSG: ethercat_trigger_controllers/MultiWaveformTransition\n"
    "# Used to specify a transition in the SetMultiWaveform service.\n"
    "\n"
    "float64 time # Transition time after start of period.\n"
    "uint32 value # Value of the digital output after the transition time.\n"
    "string topic # Topic to publish the transition timestamp to, or empty string if the transition should not be published.\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_transitions_size(uint32_t __ros_new_size)
  {
    this->transitions.resize(__ros_new_size);
  }
  inline uint32_t get_transitions_size() const { return transitions.size(); }
  uint32_t calc_transitions_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t transitions_size = transitions.size();
    for (size_t i = 0; i < transitions_size; i++)
      l += transitions[i].serializationLength();
    return l;
  }
  inline void get_transitions_vec (std::vector<ethercat_trigger_controllers::MultiWaveformTransition> &__ros_vec) const
  {
    __ros_vec = this->transitions;
  }
  inline void set_transitions_vec(const std::vector<ethercat_trigger_controllers::MultiWaveformTransition> &__ros_vec)
  {
    this->transitions = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 8; // period
    __l += 8; // zero_offset
    __l += 4 + calc_transitions_array_serialization_len(); // transitions
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, period);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, zero_offset);
    uint32_t __transitions_size = transitions.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __transitions_size);
    for (size_t i = 0; i < __transitions_size; i++)
      write_ptr = transitions[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, period);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, zero_offset);
    uint32_t __transitions_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __transitions_size);
    set_transitions_size(__transitions_size);
    for (size_t i = 0; i < __transitions_size; i++)
      read_ptr = transitions[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<MultiWaveform> MultiWaveformPtr;
typedef boost::shared_ptr<MultiWaveform const> MultiWaveformConstPtr;


}

#endif
