# autogenerated by genmsg_py from MultiWaveform.msg. Do not edit.
import roslib.message
import struct

import ethercat_trigger_controllers.msg

class MultiWaveform(roslib.message.Message):
  _md5sum = "6a8e166563c159e73f391a302e7b37f6"
  _type = "ethercat_trigger_controllers/MultiWaveform"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Transitions will occur at k * period + zero_offset + transitions[j].time, where j and
# k are integers.

float64 period # Period of the waveform in seconds.
float64 zero_offset # Time corresponding to a time of 0 in times[] in seconds
MultiWaveformTransition[] transitions # Transitions in the waveform. Transition times should be in increasing order, and be between 0 (inclusive) and period (exclusive)

================================================================================
MSG: ethercat_trigger_controllers/MultiWaveformTransition
# Used to specify a transition in the SetMultiWaveform service.

float64 time # Transition time after start of period.
uint32 value # Value of the digital output after the transition time.
string topic # Topic to publish the transition timestamp to, or empty string if the transition should not be published.

"""
  __slots__ = ['period','zero_offset','transitions']
  _slot_types = ['float64','float64','ethercat_trigger_controllers/MultiWaveformTransition[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   period,zero_offset,transitions
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(MultiWaveform, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.period is None:
        self.period = 0.
      if self.zero_offset is None:
        self.zero_offset = 0.
      if self.transitions is None:
        self.transitions = []
    else:
      self.period = 0.
      self.zero_offset = 0.
      self.transitions = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2d', self.period, self.zero_offset))
      #serialize self.transitions
      length = len(self.transitions)
      buff.write(struct.pack('<I', length))
      for val1 in self.transitions:
        buff.write(struct.pack('<dI', val1.time, val1.value))
        length = len(val1.topic)
        #serialize val1.topic
        buff.write(struct.pack('<I%ss'%length, length, val1.topic))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 16
      (self.period, self.zero_offset,) = struct.unpack('<2d',str[start:end])
      #deserialize self.transitions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.transitions = []
      for i in xrange(0, length):
        val1 = ethercat_trigger_controllers.msg.MultiWaveformTransition()
        start = end
        end += 12
        (val1.time, val1.value,) = struct.unpack('<dI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.topic
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.topic,) = struct.unpack(pattern, str[start:end])
        self.transitions.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2d', self.period, self.zero_offset))
      #serialize self.transitions
      length = len(self.transitions)
      buff.write(struct.pack('<I', length))
      for val1 in self.transitions:
        buff.write(struct.pack('<dI', val1.time, val1.value))
        length = len(val1.topic)
        #serialize val1.topic
        buff.write(struct.pack('<I%ss'%length, length, val1.topic))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 16
      (self.period, self.zero_offset,) = struct.unpack('<2d',str[start:end])
      #deserialize self.transitions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.transitions = []
      for i in xrange(0, length):
        val1 = ethercat_trigger_controllers.msg.MultiWaveformTransition()
        start = end
        end += 12
        (val1.time, val1.value,) = struct.unpack('<dI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.topic
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.topic,) = struct.unpack(pattern, str[start:end])
        self.transitions.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

