/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_controllers/pr2_controllers_msgs/msg/PointHeadGoal.msg.  Do not edit! */
#ifndef PR2_CONTROLLERS_MSGS_POINTHEADGOAL_H
#define PR2_CONTROLLERS_MSGS_POINTHEADGOAL_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/PointStamped.h"
#include "geometry_msgs/Vector3.h"

namespace pr2_controllers_msgs
{

//! \htmlinclude PointHeadGoal.msg.html

class PointHeadGoal : public ros::Message
{
public:
  typedef boost::shared_ptr<PointHeadGoal> Ptr;
  typedef boost::shared_ptr<PointHeadGoal const> ConstPtr;

  typedef geometry_msgs::PointStamped _target_type;
  typedef geometry_msgs::Vector3 _pointing_axis_type;
  typedef std::string _pointing_frame_type;
  typedef ros::Duration _min_duration_type;
  typedef double _max_velocity_type;

  geometry_msgs::PointStamped target;
  geometry_msgs::Vector3 pointing_axis;
  std::string pointing_frame;
  ros::Duration min_duration;
  double max_velocity;

  PointHeadGoal() : ros::Message(),
    max_velocity(0)
  {
  }
  PointHeadGoal(const PointHeadGoal &copy) : ros::Message(),
    target(copy.target),
    pointing_axis(copy.pointing_axis),
    pointing_frame(copy.pointing_frame),
    min_duration(copy.min_duration),
    max_velocity(copy.max_velocity)
  {
    (void)copy;
  }
  PointHeadGoal &operator =(const PointHeadGoal &copy)
  {
    if (this == &copy)
      return *this;
    target = copy.target;
    pointing_axis = copy.pointing_axis;
    pointing_frame = copy.pointing_frame;
    min_duration = copy.min_duration;
    max_velocity = copy.max_velocity;
    return *this;
  }
  virtual ~PointHeadGoal() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_controllers_msgs/PointHeadGoal"); }
  inline static std::string __s_getMD5Sum() { return std::string("8b92b1cd5e06c8a94c917dc3209a4c1d"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "geometry_msgs/PointStamped target\n"
    "geometry_msgs/Vector3 pointing_axis\n"
    "string pointing_frame\n"
    "duration min_duration\n"
    "float64 max_velocity\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PointStamped\n"
    "# This represents a Point with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Point point\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += target.serializationLength(); // target
    __l += pointing_axis.serializationLength(); // pointing_axis
    __l += 4 + pointing_frame.length(); // pointing_frame
    __l += 8; // min_duration
    __l += 8; // max_velocity
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = target.serialize(write_ptr, seq);
    write_ptr = pointing_axis.serialize(write_ptr, seq);
    unsigned __ros_pointing_frame_len = pointing_frame.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_pointing_frame_len);
    SROS_SERIALIZE_BUFFER(write_ptr, pointing_frame.c_str(), __ros_pointing_frame_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, min_duration.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, min_duration.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_velocity);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = target.deserialize(read_ptr);
    read_ptr = pointing_axis.deserialize(read_ptr);
    unsigned __ros_pointing_frame_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_pointing_frame_len);
    pointing_frame = std::string((const char *)read_ptr, __ros_pointing_frame_len);
    read_ptr += __ros_pointing_frame_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, min_duration.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, min_duration.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_velocity);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PointHeadGoal> PointHeadGoalPtr;
typedef boost::shared_ptr<PointHeadGoal const> PointHeadGoalConstPtr;


}

#endif
