# autogenerated by genmsg_py from PointHeadGoal.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import geometry_msgs.msg
import roslib.msg

class PointHeadGoal(roslib.message.Message):
  _md5sum = "8b92b1cd5e06c8a94c917dc3209a4c1d"
  _type = "pr2_controllers_msgs/PointHeadGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/PointStamped target
geometry_msgs/Vector3 pointing_axis
string pointing_frame
duration min_duration
float64 max_velocity

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['target','pointing_axis','pointing_frame','min_duration','max_velocity']
  _slot_types = ['geometry_msgs/PointStamped','geometry_msgs/Vector3','string','duration','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   target,pointing_axis,pointing_frame,min_duration,max_velocity
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PointHeadGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.target is None:
        self.target = geometry_msgs.msg.PointStamped()
      if self.pointing_axis is None:
        self.pointing_axis = geometry_msgs.msg.Vector3()
      if self.pointing_frame is None:
        self.pointing_frame = ''
      if self.min_duration is None:
        self.min_duration = roslib.rostime.Duration()
      if self.max_velocity is None:
        self.max_velocity = 0.
    else:
      self.target = geometry_msgs.msg.PointStamped()
      self.pointing_axis = geometry_msgs.msg.Vector3()
      self.pointing_frame = ''
      self.min_duration = roslib.rostime.Duration()
      self.max_velocity = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.target.header.seq, self.target.header.stamp.secs, self.target.header.stamp.nsecs))
      length = len(self.target.header.frame_id)
      #serialize self.target.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.target.header.frame_id))
      buff.write(struct.pack('<6d', self.target.point.x, self.target.point.y, self.target.point.z, self.pointing_axis.x, self.pointing_axis.y, self.pointing_axis.z))
      length = len(self.pointing_frame)
      #serialize self.pointing_frame
      buff.write(struct.pack('<I%ss'%length, length, self.pointing_frame))
      buff.write(struct.pack('<2id', self.min_duration.secs, self.min_duration.nsecs, self.max_velocity))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.target is None:
        self.target = geometry_msgs.msg.PointStamped()
      if self.pointing_axis is None:
        self.pointing_axis = geometry_msgs.msg.Vector3()
      if self.min_duration is None:
        self.min_duration = roslib.rostime.Duration()
      end = 0
      start = end
      end += 12
      (self.target.header.seq, self.target.header.stamp.secs, self.target.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.target.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.target.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 48
      (self.target.point.x, self.target.point.y, self.target.point.z, self.pointing_axis.x, self.pointing_axis.y, self.pointing_axis.z,) = struct.unpack('<6d',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pointing_frame
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pointing_frame,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.min_duration.secs, self.min_duration.nsecs, self.max_velocity,) = struct.unpack('<2id',str[start:end])
      self.min_duration.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.target.header.seq, self.target.header.stamp.secs, self.target.header.stamp.nsecs))
      length = len(self.target.header.frame_id)
      #serialize self.target.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.target.header.frame_id))
      buff.write(struct.pack('<6d', self.target.point.x, self.target.point.y, self.target.point.z, self.pointing_axis.x, self.pointing_axis.y, self.pointing_axis.z))
      length = len(self.pointing_frame)
      #serialize self.pointing_frame
      buff.write(struct.pack('<I%ss'%length, length, self.pointing_frame))
      buff.write(struct.pack('<2id', self.min_duration.secs, self.min_duration.nsecs, self.max_velocity))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.target is None:
        self.target = geometry_msgs.msg.PointStamped()
      if self.pointing_axis is None:
        self.pointing_axis = geometry_msgs.msg.Vector3()
      if self.min_duration is None:
        self.min_duration = roslib.rostime.Duration()
      end = 0
      start = end
      end += 12
      (self.target.header.seq, self.target.header.stamp.secs, self.target.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.target.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.target.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 48
      (self.target.point.x, self.target.point.y, self.target.point.z, self.pointing_axis.x, self.pointing_axis.y, self.pointing_axis.z,) = struct.unpack('<6d',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pointing_frame
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pointing_frame,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.min_duration.secs, self.min_duration.nsecs, self.max_velocity,) = struct.unpack('<2id',str[start:end])
      self.min_duration.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

