/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_controllers/pr2_mechanism_controllers/msg/BaseOdometryState.msg.  Do not edit! */
#ifndef PR2_MECHANISM_CONTROLLERS_BASEODOMETRYSTATE_H
#define PR2_MECHANISM_CONTROLLERS_BASEODOMETRYSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Twist.h"

namespace pr2_mechanism_controllers
{

//! \htmlinclude BaseOdometryState.msg.html

class BaseOdometryState : public ros::Message
{
public:
  typedef boost::shared_ptr<BaseOdometryState> Ptr;
  typedef boost::shared_ptr<BaseOdometryState const> ConstPtr;

  typedef geometry_msgs::Twist _velocity_type;
  typedef std::vector<std::string> _wheel_link_names_type;
  typedef std::vector<double> _drive_constraint_errors_type;
  typedef std::vector<double> _longitudinal_slip_constraint_errors_type;

  geometry_msgs::Twist velocity;
  std::vector<std::string> wheel_link_names;
  std::vector<double> drive_constraint_errors;
  std::vector<double> longitudinal_slip_constraint_errors;

  BaseOdometryState() : ros::Message()
  {
  }
  BaseOdometryState(const BaseOdometryState &copy) : ros::Message(),
    velocity(copy.velocity)
  {
    (void)copy;
    wheel_link_names = copy.wheel_link_names;
    drive_constraint_errors = copy.drive_constraint_errors;
    longitudinal_slip_constraint_errors = copy.longitudinal_slip_constraint_errors;
  }
  BaseOdometryState &operator =(const BaseOdometryState &copy)
  {
    if (this == &copy)
      return *this;
    wheel_link_names.clear();
    drive_constraint_errors.clear();
    longitudinal_slip_constraint_errors.clear();
    velocity = copy.velocity;
    wheel_link_names = copy.wheel_link_names;
    drive_constraint_errors = copy.drive_constraint_errors;
    longitudinal_slip_constraint_errors = copy.longitudinal_slip_constraint_errors;
    return *this;
  }
  virtual ~BaseOdometryState() 
  {
    wheel_link_names.clear();
    drive_constraint_errors.clear();
    longitudinal_slip_constraint_errors.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_controllers/BaseOdometryState"); }
  inline static std::string __s_getMD5Sum() { return std::string("8a483e137ebc37abafa4c26549091dd6"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "geometry_msgs/Twist velocity\n"
    "string[] wheel_link_names\n"
    "float64[] drive_constraint_errors\n"
    "float64[] longitudinal_slip_constraint_errors\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Twist\n"
    "# This expresses velocity in free space broken into it's linear and angular parts. \n"
    "Vector3  linear\n"
    "Vector3  angular\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_wheel_link_names_size(uint32_t __ros_new_size)
  {
    this->wheel_link_names.resize(__ros_new_size);
  }
  inline uint32_t get_wheel_link_names_size() const { return wheel_link_names.size(); }
  uint32_t calc_wheel_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t wheel_link_names_size = wheel_link_names.size();
    for (size_t i = 0; i < wheel_link_names_size; i++)
      l += 4 + wheel_link_names[i].length();
    return l;
  }
  inline void get_wheel_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->wheel_link_names;
  }
  inline void set_wheel_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->wheel_link_names = __ros_vec;
  }
  void set_drive_constraint_errors_size(uint32_t __ros_new_size)
  {
    this->drive_constraint_errors.resize(__ros_new_size);
  }
  inline uint32_t get_drive_constraint_errors_size() const { return drive_constraint_errors.size(); }
  inline void get_drive_constraint_errors_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->drive_constraint_errors;
  }
  inline void set_drive_constraint_errors_vec(const std::vector<double> &__ros_vec)
  {
    this->drive_constraint_errors = __ros_vec;
  }
  void set_longitudinal_slip_constraint_errors_size(uint32_t __ros_new_size)
  {
    this->longitudinal_slip_constraint_errors.resize(__ros_new_size);
  }
  inline uint32_t get_longitudinal_slip_constraint_errors_size() const { return longitudinal_slip_constraint_errors.size(); }
  inline void get_longitudinal_slip_constraint_errors_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->longitudinal_slip_constraint_errors;
  }
  inline void set_longitudinal_slip_constraint_errors_vec(const std::vector<double> &__ros_vec)
  {
    this->longitudinal_slip_constraint_errors = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += velocity.serializationLength(); // velocity
    __l += 4 + calc_wheel_link_names_array_serialization_len(); // wheel_link_names
    __l += 4 + (drive_constraint_errors.size() ? drive_constraint_errors.size() * 8 : 0); // drive_constraint_errors
    __l += 4 + (longitudinal_slip_constraint_errors.size() ? longitudinal_slip_constraint_errors.size() * 8 : 0); // longitudinal_slip_constraint_errors
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = velocity.serialize(write_ptr, seq);
    uint32_t __wheel_link_names_size = wheel_link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __wheel_link_names_size);
    for (size_t i = 0; i < __wheel_link_names_size; i++)
    {
      unsigned __ros_wheel_link_names_i__len = wheel_link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_wheel_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, wheel_link_names[i].c_str(), __ros_wheel_link_names_i__len);
    }
    uint32_t __drive_constraint_errors_size = drive_constraint_errors.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __drive_constraint_errors_size);
    memcpy(write_ptr, &drive_constraint_errors[0], sizeof(double) * __drive_constraint_errors_size);
    write_ptr += sizeof(double) * __drive_constraint_errors_size;
    uint32_t __longitudinal_slip_constraint_errors_size = longitudinal_slip_constraint_errors.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __longitudinal_slip_constraint_errors_size);
    memcpy(write_ptr, &longitudinal_slip_constraint_errors[0], sizeof(double) * __longitudinal_slip_constraint_errors_size);
    write_ptr += sizeof(double) * __longitudinal_slip_constraint_errors_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = velocity.deserialize(read_ptr);
    uint32_t __wheel_link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __wheel_link_names_size);
    set_wheel_link_names_size(__wheel_link_names_size);
    for (size_t i = 0; i < __wheel_link_names_size; i++)
    {
      unsigned __ros_wheel_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_wheel_link_names_i__len);
    wheel_link_names[i] = std::string((const char *)read_ptr, __ros_wheel_link_names_i__len);
    read_ptr += __ros_wheel_link_names_i__len;
    }
    uint32_t __drive_constraint_errors_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __drive_constraint_errors_size);
    set_drive_constraint_errors_size(__drive_constraint_errors_size);
    memcpy(&drive_constraint_errors[0], read_ptr, sizeof(double) * __drive_constraint_errors_size);
    read_ptr += sizeof(double) * __drive_constraint_errors_size;
    uint32_t __longitudinal_slip_constraint_errors_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __longitudinal_slip_constraint_errors_size);
    set_longitudinal_slip_constraint_errors_size(__longitudinal_slip_constraint_errors_size);
    memcpy(&longitudinal_slip_constraint_errors[0], read_ptr, sizeof(double) * __longitudinal_slip_constraint_errors_size);
    read_ptr += sizeof(double) * __longitudinal_slip_constraint_errors_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<BaseOdometryState> BaseOdometryStatePtr;
typedef boost::shared_ptr<BaseOdometryState const> BaseOdometryStateConstPtr;


}

#endif
