# autogenerated by genmsg_py from BaseOdometryState.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg

class BaseOdometryState(roslib.message.Message):
  _md5sum = "8a483e137ebc37abafa4c26549091dd6"
  _type = "pr2_mechanism_controllers/BaseOdometryState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Twist velocity
string[] wheel_link_names
float64[] drive_constraint_errors
float64[] longitudinal_slip_constraint_errors
================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into it's linear and angular parts. 
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['velocity','wheel_link_names','drive_constraint_errors','longitudinal_slip_constraint_errors']
  _slot_types = ['geometry_msgs/Twist','string[]','float64[]','float64[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   velocity,wheel_link_names,drive_constraint_errors,longitudinal_slip_constraint_errors
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(BaseOdometryState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.velocity is None:
        self.velocity = geometry_msgs.msg.Twist()
      if self.wheel_link_names is None:
        self.wheel_link_names = []
      if self.drive_constraint_errors is None:
        self.drive_constraint_errors = []
      if self.longitudinal_slip_constraint_errors is None:
        self.longitudinal_slip_constraint_errors = []
    else:
      self.velocity = geometry_msgs.msg.Twist()
      self.wheel_link_names = []
      self.drive_constraint_errors = []
      self.longitudinal_slip_constraint_errors = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<6d', self.velocity.linear.x, self.velocity.linear.y, self.velocity.linear.z, self.velocity.angular.x, self.velocity.angular.y, self.velocity.angular.z))
      #serialize self.wheel_link_names
      length = len(self.wheel_link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.wheel_link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.drive_constraint_errors
      length = len(self.drive_constraint_errors)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.drive_constraint_errors))
      #serialize self.longitudinal_slip_constraint_errors
      length = len(self.longitudinal_slip_constraint_errors)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.longitudinal_slip_constraint_errors))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.velocity is None:
        self.velocity = geometry_msgs.msg.Twist()
      end = 0
      start = end
      end += 48
      (self.velocity.linear.x, self.velocity.linear.y, self.velocity.linear.z, self.velocity.angular.x, self.velocity.angular.y, self.velocity.angular.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.wheel_link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.wheel_link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.wheel_link_names.append(val1)
      #deserialize self.drive_constraint_errors
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_constraint_errors = struct.unpack(pattern, str[start:end])
      #deserialize self.longitudinal_slip_constraint_errors
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.longitudinal_slip_constraint_errors = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<6d', self.velocity.linear.x, self.velocity.linear.y, self.velocity.linear.z, self.velocity.angular.x, self.velocity.angular.y, self.velocity.angular.z))
      #serialize self.wheel_link_names
      length = len(self.wheel_link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.wheel_link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.drive_constraint_errors
      length = len(self.drive_constraint_errors)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.drive_constraint_errors.tostring())
      #serialize self.longitudinal_slip_constraint_errors
      length = len(self.longitudinal_slip_constraint_errors)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.longitudinal_slip_constraint_errors.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.velocity is None:
        self.velocity = geometry_msgs.msg.Twist()
      end = 0
      start = end
      end += 48
      (self.velocity.linear.x, self.velocity.linear.y, self.velocity.linear.z, self.velocity.angular.x, self.velocity.angular.y, self.velocity.angular.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.wheel_link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.wheel_link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.wheel_link_names.append(val1)
      #deserialize self.drive_constraint_errors
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_constraint_errors = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.longitudinal_slip_constraint_errors
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.longitudinal_slip_constraint_errors = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

